## pg-auto-failover 2.1

=== Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

.DEFAULT_GOAL := all

# Supported PostgreSQL versions:
PGVERSIONS = 11 12 13 14 15 16

# Default version:
PGVERSION ?= $(lastword $(PGVERSIONS))

# PostgreSQL cluster option
# could be "--skip-pg-hba"
CLUSTER_OPTS = ""

# XXXX This should be in Makefile.citus only
# but requires to clean up dockerfile and make targets related to citus first.
# Default Citus Data version
CITUSTAG ?= v12.1.0

# TODO should be abs_top_dir ?
TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Get pg_auto_failover version from header file
VERSION_FILE = src/bin/pg_autoctl/git-version.h
ifeq ("$(wildcard $(VERSION_FILE))","")
DUMMY := $(shell git update-index -q --refresh)
GIT_DIRTY := $(shell test -z "`git diff-index --name-only HEAD --`" || echo "-dirty")
GIT_VVERSION := $(shell git describe --match "v[0-9]*" HEAD 2>/dev/null)
GIT_DVERSION := $(shell echo $(GIT_VVERSION) | awk -Fv '{print $$2"$(GIT_DIRTY)"}')
GIT_VERSION := $(shell echo $(GIT_DVERSION) | sed -e 's/-/./g')
else
GIT_VERSION := $(shell awk -F '[ "]' '{print $$4}' $(VERSION_FILE))
endif

# Azure only targets and variables are in a separate Makefile
include Makefile.azure

#
# LIST TESTS
#
NOSETESTS = $(shell which nosetests3 || which nosetests)

# Tests for the monitor
TESTS_MONITOR  = test_extension_update
TESTS_MONITOR += test_installcheck
TESTS_MONITOR += test_monitor_disabled
TESTS_MONITOR += test_replace_monitor

# This could be in TESTS_MULTI, but adding it here optimizes Travis run time
TESTS_MONITOR += test_multi_alternate_primary_failures

# Tests for single standby
TESTS_SINGLE  = test_auth
TESTS_SINGLE += test_basic_operation
TESTS_SINGLE += test_basic_operation_listen_flag
TESTS_SINGLE += test_create_run
TESTS_SINGLE += test_create_standby_with_pgdata
TESTS_SINGLE += test_ensure
TESTS_SINGLE += test_skip_pg_hba
TESTS_SINGLE += test_config_get_set

# Tests for SSL
TESTS_SSL  = test_enable_ssl
TESTS_SSL += test_ssl_cert
TESTS_SSL += test_ssl_self_signed

# This could be in TESTS_SINGLE, but adding it here optimizes Travis run time
TESTS_SSL += test_debian_clusters

# Tests for multiple standbys
TESTS_MULTI  = test_multi_async
TESTS_MULTI += test_multi_ifdown
TESTS_MULTI += test_multi_maintenance
TESTS_MULTI += test_multi_standbys

# TEST indicates the testfile to run
# Included Makefile may define TEST_ARGUMENT (like for citus)
TEST ?=
ifeq ($(TEST),)
	TEST_ARGUMENT = --where=tests
else ifeq ($(TEST),multi)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_MULTI)
else ifeq ($(TEST),single)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_SINGLE)
else ifeq ($(TEST),monitor)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_MONITOR)
else ifeq ($(TEST),ssl)
	TEST_ARGUMENT = --where=tests --tests=$(TESTS_SSL)
else
	TEST_ARGUMENT = $(TEST:%=tests/%.py)
endif

#
# Main make targets
#
.PHONY: all
all: monitor bin ;

.PHONY: bin
bin: version
	$(MAKE) -C src/bin/ all

.PHONY: check-monitor
check: check-monitor ;

.PHONY: check-monitor
check-monitor: install-monitor
	$(MAKE) -C src/monitor/ installcheck

.PHONY: clean
clean: clean-monitor clean-bin ;

.PHONY: clean-bin
clean-bin:
	$(MAKE) -C src/bin/ clean

.PHONY: clean-monitor
clean-monitor:
	$(MAKE) -C src/monitor/ clean

.PHONY: clean-version
clean-version:
	rm -f $(VERSION_FILE)

.PHONY: install
install: install-monitor install-bin ;

.PHONY: install-bin
install-bin: bin
	$(MAKE) -C src/bin/ install

.PHONY: install-monitor
install-monitor: monitor
	$(MAKE) -C src/monitor/ install

.PHONY: maintainer-clean
maintainer-clean: clean-monitor clean-version clean-bin ;

.PHONY: monitor
monitor:
	$(MAKE) -C src/monitor/ all

.PHONY: version
version: $(VERSION_FILE) ;

$(VERSION_FILE):
	@echo "#define GIT_VERSION \""$(GIT_VERSION)"\"" > $@

#
# make ci-test; is run on the GitHub Action workflow
#
# In that environment we have a local git checkout of the code, and docker
# is available too. We run our tests in docker, except for the code linting
# parts which requires full access to the git repository, so linter tooling
# is installed directly on the CI vm.
#
.PHONY: ci-test
ci-test:
ifeq ($(TEST),tablespaces)
	$(MAKE) -C tests/tablespaces run-test
else ifeq ($(TEST),linting)
	$(MAKE) spellcheck
else
	$(MAKE) run-test
endif

#
# make test; is run from inside the testing Docker image.
#
.PHONY: test
test:
ifeq ($(TEST),tablespaces)
	$(MAKE) -C tests/tablespaces run-test
else ifeq ($(TEST),linting)
	$(MAKE) spellcheck
else
	sudo -E env "PATH=${PATH}" USER=$(shell whoami) \
		$(NOSETESTS)			\
		--verbose				\
		--nologcapture			\
		--nocapture				\
		--stop					\
		${TEST_ARGUMENT}
endif

#
# INDENT/LINT/SPELLCHECK
#
# make indent; edits the code when necessary
.PHONY: indent
indent:
	citus_indent
	black .

# make lint; is an alias for make spellcheck
# make linting; is an alias for make spellcheck
.PHONY: lint linting
lint linting: spellcheck ;

# make spellcheck; runs our linting tools without editing the code, only
# reports compliance with the rules.
.PHONY: spellcheck
spellcheck:
	citus_indent --check
	black --check .
	ci/banned.h.sh

#
# DOCS
#
# Documentation and images
FSM = docs/fsm.png
PDF = ./docs/_build/latex/pg_auto_failover.pdf

# make serve-docs uses this port on localhost to expose the web server
DOCS_PORT = 8000

.PHONY: man
man:
	$(MAKE) -C docs man

.PHONY: pdf
pdf: $(PDF) ;

$(PDF):
	$(MAKE) -s -C docs/tikz pdf
	perl -pi -e 's/(^.. figure:: .*)\.svg/\1.pdf/' docs/*.rst
	perl -pi -e 's/▒/~/g' docs/ref/pg_autoctl_do_demo.rst
	$(MAKE) -s -C docs latexpdf
	perl -pi -e 's/(^.. figure:: .*)\.pdf/\1.svg/' docs/*.rst
	perl -pi -e 's/~/▒/g' docs/ref/pg_autoctl_do_demo.rst
	ls -l $@

$(FSM): bin
	$(PG_AUTOCTL) do fsm gv | dot -Tpng > $@

.PHONY: docs
docs: $(FSM) tikz
	$(MAKE) -C docs html

.PHONY: build-docs
build-docs:
	docker build -t pg_auto_failover:docs -f Dockerfile.docs .

.PHONY: serve-docs
serve-docs: build-docs
	docker run --rm -it -p $(DOCS_PORT):8000 pg_auto_failover:docs

.PHONY: tikz
tikz:
	$(MAKE) -C docs/tikz all

#
# DOCKER
#

CONTAINER_NAME = pg_auto_failover
BUILD_CONTAINER_NAME = pg_auto_failover_build
TEST_CONTAINER_NAME = pg_auto_failover_test
DOCKER_RUN_OPTS = --privileged --rm

#
# Include Citus only for testing purpose
#
ifeq ($(TEST),citus)
  CITUS=1
endif

ifeq ($(CITUS),1)
include Makefile.citus
endif

# We use pg not PG in uppercase in the var name to ease implicit rules matching
BUILD_ARGS_pg11 = --build-arg PGVERSION=11 --build-arg CITUSTAG=v9.5.10
BUILD_ARGS_pg12 = --build-arg PGVERSION=12 --build-arg CITUSTAG=v10.2.9
BUILD_ARGS_pg13 = --build-arg PGVERSION=13 --build-arg CITUSTAG=v10.2.9
BUILD_ARGS_pg14 = --build-arg PGVERSION=14 --build-arg CITUSTAG=$(CITUSTAG)
BUILD_ARGS_pg15 = --build-arg PGVERSION=15 --build-arg CITUSTAG=$(CITUSTAG)
BUILD_ARGS_pg16 = --build-arg PGVERSION=16 --build-arg CITUSTAG=$(CITUSTAG)

# DOCKER BUILDS

BUILD_TARGETS       = $(patsubst %,build-pg%,$(PGVERSIONS))
.PHONY: build
build: $(BUILD_TARGETS) ;

.PHONY: build-demo
build-demo:
	docker build $(BUILD_ARGS_pg$(PGVERSION)) -t citusdata/pg_auto_failover:demo .

.PHONY: build-i386
build-i386: Dockerfile.i386
	docker build -t i386:latest -f Dockerfile.i386 .

.PHONY: build-image
build-image:
	docker build --target build -t $(BUILD_CONTAINER_NAME) .

.PHONY: $(BUILD_TARGETS)
$(BUILD_TARGETS): version
	docker build \
	  $(BUILD_ARGS_$(subst build-,,$@)) \
	  -t $(CONTAINER_NAME):$(subst build-,,$@) .

# DOCKER TESTS & CHECKS

BUILD_CHECK_TARGETS = $(patsubst %,build-check-pg%,$(PGVERSIONS))
BUILD_TEST_TARGETS  = $(patsubst %,build-test-pg%,$(PGVERSIONS))

.PHONY: build-check
build-check: $(BUILD_CHECK_TARGETS)

.PHONY: build-check
build-test: $(BUILD_TEST_TARGETS)

.PHONY: build-test-image
build-test-image: build-test-pg$(PGVERSION) ;

.PHONY: $(BUILD_TEST_TARGETS)
$(BUILD_TEST_TARGETS): version
	docker build \
	  $(BUILD_ARGS_$(subst build-test-,,$@)) \
	  --target test \
	  -t $(TEST_CONTAINER_NAME):$(subst build-test-,,$@) .

.SECONDEXPANSION:
.PHONY: $(BUILD_CHECK_TARGETS)
$(BUILD_CHECK_TARGETS): version $$(subst build-check-,build-test-,$$@)
	docker run --rm \
	  -t $(TEST_CONTAINER_NAME):$(subst build-check-,,$@) \
	  pg_autoctl version --json | jq ".pg_version" | xargs echo $(subst build-check-,,$@):

# make run-test; is the main testing entry point used to run tests inside
# our testing Docker container. The docker container depends on PGVERSION.
.PHONY: run-test
run-test: build-test-pg$(PGVERSION)
	docker run					                \
		--name $(TEST_CONTAINER_NAME)		    \
		$(DOCKER_RUN_OPTS)			            \
		$(TEST_CONTAINER_NAME):pg$(PGVERSION)   \
		make -C /usr/src/pg_auto_failover test	\
		PGVERSION=$(PGVERSION) TEST='${TEST}'

# expected to be run from within the i386 docker container
.PHONY: installcheck-i386
installcheck-i386:
	pg_autoctl run &
	pg_autoctl do pgsetup wait
	$(MAKE) -C src/monitor installcheck

.PHONY: run-installcheck-i386
run-installcheck-i386: build-i386
	docker run --platform linux/386 --rm -it --privileged i386 make installcheck-i386

#
# BE INTERACTIVE
#

FIRST_PGPORT ?= 5500

TMUX_EXTRA_COMMANDS ?= ""
TMUX_LAYOUT ?= even-vertical	# could be "tiled"
TMUX_TOP_DIR = ./tmux/pgsql
TMUX_SCRIPT = ./tmux/script-$(FIRST_PGPORT).tmux
TMUX_CITUS = ""

# PostgreSQL testing
## total count of Postgres nodes
NODES ?= 2
## count of replication-quorum false nodes
NODES_ASYNC ?= 0
## either "50", or "50,50", or "50,50,0" etc
NODES_PRIOS ?= 50
## TODO ???
NODES_SYNC_SB ?= -1

.PHONY: interactive-test
interactive-test:
	docker run --name $(CONTAINER_NAME) --rm -ti $(CONTAINER_NAME)

.PHONY: $(TMUX_SCRIPT)
$(TMUX_SCRIPT): bin
	mkdir -p $(TMUX_TOP_DIR)
	$(PG_AUTOCTL) do tmux script          \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)                 \
         --async-nodes $(NODES_ASYNC)     \
         --node-priorities $(NODES_PRIOS) \
         --sync-standbys $(NODES_SYNC_SB) \
         $(TMUX_CITUS)                    \
         $(CLUSTER_OPTS)                  \
         --binpath $(BINPATH)             \
		 --layout $(TMUX_LAYOUT) > $@

.PHONY: tmux-script
tmux-script: $(TMUX_SCRIPT) ;

.PHONY: tmux-clean
tmux-clean: bin
	$(PG_AUTOCTL) do tmux clean           \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)                 \
         $(TMUX_CITUS)                    \
         $(CLUSTER_OPTS)

.PHONY: tmux-session
tmux-session: bin
	$(PG_AUTOCTL) do tmux session         \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)                 \
         --async-nodes $(NODES_ASYNC)     \
         --node-priorities $(NODES_PRIOS) \
         --sync-standbys $(NODES_SYNC_SB) \
         $(TMUX_CITUS)                    \
         $(CLUSTER_OPTS)                  \
         --binpath $(BINPATH)             \
         --layout $(TMUX_LAYOUT)

.PHONY: tmux-compose-session
tmux-compose-session:
	$(PG_AUTOCTL) do tmux compose session \
         --root $(TMUX_TOP_DIR)           \
         --first-pgport $(FIRST_PGPORT)   \
         --nodes $(NODES)                 \
         --async-nodes $(NODES_ASYNC)     \
         --node-priorities $(NODES_PRIOS) \
         --sync-standbys $(NODES_SYNC_SB) \
         $(TMUX_CITUS)                    \
         $(CLUSTER_OPTS)                  \
         --binpath $(BINPATH)             \
         --layout $(TMUX_LAYOUT)

.PHONY: cluster
cluster: install tmux-clean
	# This is explicitly not a target, otherwise when make uses multiple jobs
	# tmux-clean and tmux-session can have a race condidition where tmux-clean
	# removes the files that are just created by tmux-session.
	$(MAKE) tmux-session

.PHONY: compose
compose:
	$(MAKE) tmux-compose-session

# Command line with DEBUG facilities
VALGRIND ?=
ifeq ($(VALGRIND),)
	BINPATH = ./src/bin/pg_autoctl/pg_autoctl
	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 ./src/bin/pg_autoctl/pg_autoctl
else

=== docs/requirements.txt ===
Sphinx==4.0.2
sphinx_rtd_theme_citus==0.5.25
docutils==0.16
readthedocs-sphinx-search==0.1.0

=== src/Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

all: monitor bin ;
clean: clean-monitor clean-bin ;
install: install-monitor install-bin ;

monitor:
	$(MAKE) -C monitor all

install-monitor:
	$(MAKE) -C monitor install

clean-monitor:
	$(MAKE) -C monitor clean

bin:
	$(MAKE) -C bin all

install-bin:
	$(MAKE) -C bin install

clean-bin:
	$(MAKE) -C bin clean


.PHONY: all clean bin test monitor
.PHONY: clean-monitor clean-bin install-monitor install-bin

=== docs/citus/Makefile ===
CONTAINER_NAME = pg_auto_failover:citus

all: build down up ;

scale: build scale-down scale-up ;

build:
	docker build -t $(CONTAINER_NAME) -f Dockerfile ../..
	docker-compose build

scale-up:
	docker-compose -f docker-compose-scale.yml up --scale coord=2 --scale worker=6

scale-down:
	docker-compose -f docker-compose-scale.yml down

up:
	docker-compose up

down:
	docker-compose down

state:
	docker-compose exec monitor pg_autoctl show state

failover:
	docker-compose exec monitor pg_autoctl perform failover --group 1

nodes:
	docker-compose exec coord psql -d analytics -c 'table pg_dist_node'

.PHONY: all scale build scale-up scale-down up down state failover nodes

=== docs/tutorial/Makefile ===
CONTAINER_NAME = pg_auto_failover:tutorial

all: build down up;

build:
	docker-compose build

up:
	docker-compose up app monitor node1 node2

node3:
	docker-compose up -d node3

down:
	docker-compose down

state:
	docker-compose exec monitor pg_autoctl show state

switchover:
	docker-compose exec monitor pg_autoctl perform switchover

watch:
	docker-compose exec monitor pg_autoctl watch

=== src/bin/Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

all: pg_autoctl ;

pg_autoctl:
	$(MAKE) -C pg_autoctl pg_autoctl

clean:
	$(MAKE) -C pg_autoctl clean

install: $(pg_autoctl)
	$(MAKE) -C pg_autoctl install

.PHONY: all pg_autoctl install clean

=== src/monitor/Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

EXTENSION = pgautofailover
EXTVERSION = 2.1

SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

DATA_built = $(EXTENSION)--$(EXTVERSION).sql
DATA = $(EXTENSION)--1.0.sql $(patsubst ${SRC_DIR}%,%,$(wildcard ${SRC_DIR}$(EXTENSION)--*--*.sql))

# compilation configuration
MODULE_big = $(EXTENSION)
OBJS = $(patsubst ${SRC_DIR}%.c,%.o,$(wildcard ${SRC_DIR}*.c))
PG_CPPFLAGS = -std=c99 -Wall -Werror -Wno-unused-parameter -Iinclude -I$(libpq_srcdir) -g
SHLIB_LINK = $(libpq)
REGRESS = create_extension monitor workers dummy_update drop_extension upgrade

PG_CONFIG ?= pg_config
PGXS = $(shell $(PG_CONFIG) --pgxs)
USE_PGXS = 1

.PHONY: cleanup-before-install

DEFAULT_CFLAGS = -std=c99 -D_GNU_SOURCE -g
DEFAULT_CFLAGS += $(shell $(PG_CONFIG) --cflags)
DEFAULT_CFLAGS += -Wformat
DEFAULT_CFLAGS += -Wall
DEFAULT_CFLAGS += -Werror=implicit-int
DEFAULT_CFLAGS += -Werror=implicit-function-declaration
DEFAULT_CFLAGS += -Werror=return-type
DEFAULT_CFLAGS += -Wno-declaration-after-statement

# Needed for OSX
DEFAULT_CFLAGS += -Wno-missing-braces

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_CFLAGS=-fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2 -z noexecstack -fpic -shared -Wl,-z,relro -Wl,-z,now -Wformat -Wformat-security -Werror=format-security
DEFAULT_CFLAGS += $(SECURITY_CFLAGS)
endif

override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)

include $(PGXS)

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_BITCODE_CFLAGS=-fsanitize=safe-stack -fstack-protector-strong -flto -fPIC -Wformat -Wformat-security -Werror=format-security
override BITCODE_CFLAGS := $(BITCODE_CFLAGS) $(SECURITY_BITCODE_CFLAGS)
endif

cleanup-before-install:
	rm -f $(DESTDIR)$(datadir)/$(datamoduledir)/pgautofailover*

install: cleanup-before-install

$(EXTENSION)--$(EXTVERSION).sql: $(EXTENSION).sql
	cat $^ > $@

=== tests/tablespaces/Makefile ===
PGVERSION ?= 10

build:
	$(MAKE) -C ../../ build-test-pg$(PGVERSION)
	docker-compose build --build-arg "PGVERSION=$(PGVERSION)"

teardown:
	docker-compose down --volumes --remove-orphans

tail:
	docker-compose logs -f

state:
	docker-compose exec -T monitor pg_autoctl show state

watch:
	docker-compose exec -T monitor pg_autoctl watch

test_01:
	docker-compose up -d node1
	TEST_NUM="01" docker-compose up --exit-code-from=test test

test_02:
	docker-compose up -d node2
	TEST_NUM="02" docker-compose up --exit-code-from=test test

test_03:
	# Pollute the data dir so pg_rewind fails
	docker-compose exec -T node2 mkdir '/var/lib/postgres/data/base/1/99999999'
	docker-compose exec -T monitor pg_autoctl perform failover
	TEST_NUM="03" docker-compose up --exit-code-from=test test

test_04:
	docker-compose pause node1
	TEST_NUM="04" docker-compose up --exit-code-from=test test

test_05:
	docker-compose unpause node1
	TEST_NUM="05" docker-compose up --exit-code-from=test test

test_06:
	docker-compose exec -T monitor pg_autoctl perform failover
	TEST_NUM="06" docker-compose up --exit-code-from=test test

test: build test_01 test_02 test_03 test_04 test_05 test_06

#  The test containers only connect to each other via the postgres protocol.
#    For this reason, the Makefile uses  `docker-compose exec` to perform
#    `pg_autoctl` commands, such as failover. Starting/stopping the pg_autoctl
#    process is also done using `docker-compose` so as not to complicate the
#    command used to run each container.
#  See CONTRIBUTING.md for more detailed instructions.
run-test: test teardown

.PHONY: build state watch run-test test tail teardown test_01 test_02 test_03 test_04 test_05 test_06

=== debian/changelog ===
pg-auto-failover (2.1-2) unstable; urgency=medium

  * Relax dependency on pg-auto-failover-cli to >= so we can stop building
    packages for older PG versions without making them uninstallable.

 -- Christoph Berg <myon@debian.org>  Sat, 25 Nov 2023 09:52:08 +0000

pg-auto-failover (2.1-1) unstable; urgency=medium

  * New upstream version 2.1.
  * debian/rules: Generate src/bin/pg_autoctl/git-version.h.
  * debian/pgversions: Bump to 11+.

 -- Christoph Berg <myon@debian.org>  Fri, 24 Nov 2023 16:35:57 +0000

pg-auto-failover (2.0-3) unstable; urgency=medium

  * Upload for PostgreSQL 16.

 -- Christoph Berg <myon@debian.org>  Fri, 17 Nov 2023 09:56:02 +0000

=== debian/control ===
Source: pg-auto-failover
Section: database
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 flex,
 libedit-dev,
 libkrb5-dev,
 liblz4-dev,
 libncurses-dev,
 libpam0g-dev,
 libreadline-dev,
 libselinux1-dev,
 libssl-dev,
 libxslt1-dev,
 libzstd-dev,
 postgresql-server-dev-all (>= 158~),
 python3-sphinx,
 zlib1g-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/citusdata/pg_auto_failover

Package: pg-auto-failover-cli
Architecture: any
Depends:
 openssl,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 postgresql-11-auto-failover | postgresql-12-auto-failover | postgresql-13-auto-failover | postgresql-14-auto-failover | postgresql-15-auto-failover | postgresql-16-auto-failover,
Description: Command line interface and service to manage pg auto failover Clusters
 This CLI is used to manage pg_auto_failover installations to provide High
 Availability to Postgres.

Package: postgresql-16-auto-failover
Architecture: any
Depends:
 pg-auto-failover-cli (>= ${binary:Version}),
 postgresql-16,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Postgres high availability support
 This extension implements a set of functions to provide High Availability to
 Postgres.

=== debian/tests/control ===
Depends: @, postgresql-contrib-16
Tests: installcheck
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/citusdata/pg_auto_failover/tags .*/v?(\d\S*)\.tar\.gz

## pg-auto-failover 2.2

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 .DEFAULT_GOAL := all
 
 # Supported PostgreSQL versions:
-PGVERSIONS = 11 12 13 14 15 16
+PGVERSIONS = 13 14 15 16 17
 
 # Default version:
 PGVERSION ?= $(lastword $(PGVERSIONS))
@@ -16,7 +16,7 @@
 # XXXX This should be in Makefile.citus only
 # but requires to clean up dockerfile and make targets related to citus first.
 # Default Citus Data version
-CITUSTAG ?= v12.1.0
+CITUSTAG ?= v13.0.1
 
 # TODO should be abs_top_dir ?
 TOP := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
@@ -191,7 +191,7 @@
 .PHONY: indent
 indent:
 	citus_indent
-	black .
+	black --exclude=ci/tools .
 
 # make lint; is an alias for make spellcheck
 # make linting; is an alias for make spellcheck
@@ -203,7 +203,7 @@
 .PHONY: spellcheck
 spellcheck:
 	citus_indent --check
-	black --check .
+	black --exclude=ci/tools --check .
 	ci/banned.h.sh
 
 #
@@ -272,12 +272,11 @@
 endif
 
 # We use pg not PG in uppercase in the var name to ease implicit rules matching
-BUILD_ARGS_pg11 = --build-arg PGVERSION=11 --build-arg CITUSTAG=v9.5.10
-BUILD_ARGS_pg12 = --build-arg PGVERSION=12 --build-arg CITUSTAG=v10.2.9
 BUILD_ARGS_pg13 = --build-arg PGVERSION=13 --build-arg CITUSTAG=v10.2.9
-BUILD_ARGS_pg14 = --build-arg PGVERSION=14 --build-arg CITUSTAG=$(CITUSTAG)
-BUILD_ARGS_pg15 = --build-arg PGVERSION=15 --build-arg CITUSTAG=$(CITUSTAG)
+BUILD_ARGS_pg14 = --build-arg PGVERSION=14 --build-arg CITUSTAG=v12.1.5
+BUILD_ARGS_pg15 = --build-arg PGVERSION=15 --build-arg CITUSTAG=v12.1.5
 BUILD_ARGS_pg16 = --build-arg PGVERSION=16 --build-arg CITUSTAG=$(CITUSTAG)
+BUILD_ARGS_pg17 = --build-arg PGVERSION=17 --build-arg CITUSTAG=$(CITUSTAG)
 
 # DOCKER BUILDS
 
@@ -288,10 +287,6 @@
 .PHONY: build-demo
 build-demo:
 	docker build $(BUILD_ARGS_pg$(PGVERSION)) -t citusdata/pg_auto_failover:demo .
-
-.PHONY: build-i386
-build-i386: Dockerfile.i386
-	docker build -t i386:latest -f Dockerfile.i386 .
 
 .PHONY: build-image
 build-image:
@@ -341,17 +336,6 @@
 		$(TEST_CONTAINER_NAME):pg$(PGVERSION)   \
 		make -C /usr/src/pg_auto_failover test	\
 		PGVERSION=$(PGVERSION) TEST='${TEST}'
-
-# expected to be run from within the i386 docker container
-.PHONY: installcheck-i386
-installcheck-i386:
-	pg_autoctl run &
-	pg_autoctl do pgsetup wait
-	$(MAKE) -C src/monitor installcheck
-
-.PHONY: run-installcheck-i386
-run-installcheck-i386: build-i386
-	docker run --platform linux/386 --rm -it --privileged i386 make installcheck-i386
 
 #
 # BE INTERACTIVE
@@ -451,3 +435,14 @@
 	BINPATH = ./src/bin/pg_autoctl/pg_autoctl
 	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 ./src/bin/pg_autoctl/pg_autoctl
 else
+	BINPATH = $(abspath $(TOP))/src/tools/pg_autoctl.valgrind
+	PG_AUTOCTL = PG_AUTOCTL_DEBUG=1 PG_AUTOCTL_DEBUG_BIN_PATH="$(BINPATH)" ./src/tools/pg_autoctl.valgrind
+endif
+
+VALGRIND_SESSION_TARGETS  = $(patsubst %,valgrind-session-pg%,$(PGVERSIONS))
+
+.SECONDEXPANSION:
+.PHONY: $(VALGRIND_SESSION_TARGETS)
+$(VALGRIND_SESSION_TARGETS): version $$(subst valgrind-session-,build-test-,$$@)
+	docker run
+	  --name $(TEST_CONTAINER_NAME)                \

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = pg_auto_failover
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/citus/Makefile ===
CONTAINER_NAME = pg_auto_failover:citus

all: build down up ;

scale: build scale-down scale-up ;

build:
	docker build -t $(CONTAINER_NAME) -f Dockerfile ../..
	docker compose build

scale-up:
	docker compose -f docker-compose-scale.yml up --scale coord=2 --scale worker=6

scale-down:
	docker compose -f docker-compose-scale.yml down

up:
	docker compose up

down:
	docker compose down

state:
	docker compose exec monitor pg_autoctl show state

failover:
	docker compose exec monitor pg_autoctl perform failover --group 1

nodes:
	docker compose exec coord psql -d analytics -c 'table pg_dist_node'

.PHONY: all scale build scale-up scale-down up down state failover nodes

=== docs/tikz/Makefile ===
SRC = $(wildcard arch*.tex fsm.tex)
PDF = $(SRC:.tex=.pdf)
SVG = $(SRC:.tex=.svg)
PNG = $(SRC:.tex=.png)

all: pdf svg png ;

pdf: $(SRC) $(PDF) ;
svg: $(SRC) $(SVG) ;
png: $(SRC) $(PNG) ;

clean:
	latexmk -C
	rm -rf $(PDF)
	rm -rf $(SVG)
	rm -rf $(PNG)

%.pdf: %.tex common.tex
	latexmk -silent -lualatex --interaction=nonstopmode -shell-escape $<
	latexmk -c

%.png: %.pdf
	pdftocairo -singlefile -r 300 -transp -png $<

%.svg: %.pdf
	pdftocairo -svg $<

.PHONY: clean

=== docs/tutorial/Makefile ===
CONTAINER_NAME = pg_auto_failover:tutorial

all: build down up;

build:
	docker compose build

up:
	docker compose up app monitor node1 node2

node3:
	docker compose up -d node3

down:
	docker compose down

state:
	docker compose exec monitor pg_autoctl show state

switchover:
	docker compose exec monitor pg_autoctl perform switchover

watch:
	docker compose exec monitor pg_autoctl watch

=== src/monitor/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # Licensed under the PostgreSQL License.
 
 EXTENSION = pgautofailover
-EXTVERSION = 2.1
+EXTVERSION = 2.2
 
 SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

=== tests/tablespaces/Makefile ===
PGVERSION ?= 14

build:
	$(MAKE) -C ../../ build-test-pg$(PGVERSION)
	docker compose build --build-arg "PGVERSION=$(PGVERSION)"

teardown:
	docker compose down --volumes --remove-orphans

tail:
	docker compose logs -f

state:
	docker compose exec -T monitor pg_autoctl show state

watch:
	docker compose exec -T monitor pg_autoctl watch

test_01:
	docker compose up -d node1
	TEST_NUM="01" docker compose up --exit-code-from=test test

test_02:
	docker compose up -d node2
	TEST_NUM="02" docker compose up --exit-code-from=test test

test_03:
	# Pollute the data dir so pg_rewind fails
	docker compose exec -T node2 mkdir '/var/lib/postgres/data/base/1/99999999'
	docker compose exec -T monitor pg_autoctl perform failover
	TEST_NUM="03" docker compose up --exit-code-from=test test

test_04:
	docker compose pause node1
	TEST_NUM="04" docker compose up --exit-code-from=test test

test_05:
	docker compose unpause node1
	TEST_NUM="05" docker compose up --exit-code-from=test test

test_06:
	docker compose exec -T monitor pg_autoctl perform failover
	TEST_NUM="06" docker compose up --exit-code-from=test test

test: build test_01 test_02 test_03 test_04 test_05 test_06

#  The test containers only connect to each other via the postgres protocol.
#    For this reason, the Makefile uses  `docker compose exec` to perform
#    `pg_autoctl` commands, such as failover. Starting/stopping the pg_autoctl
#    process is also done using `docker compose` so as not to complicate the
#    command used to run each container.
#  See CONTRIBUTING.md for more detailed instructions.
run-test: test teardown

.PHONY: build state watch run-test test tail teardown test_01 test_02 test_03 test_04 test_05 test_06

=== tests/upgrade/Makefile ===
NODES ?= 3

PATCH = tests/upgrade/monitor-upgrade-1.7.patch
Q_VERSION = select default_version, installed_version
Q_VERSION += from pg_available_extensions where name = 'pgautofailover'

build:
	docker compose build

patch:
	cd ../.. && git apply $(PATCH)

clean:
	cd ../.. && git apply --reverse $(PATCH)

up: create-volumes compose-up tail ;

down: compose-down rm-volumes ;

compose-down:
	docker compose down --volumes --remove-orphans

compose-up:
	docker compose up -d

tail:
	docker compose logs -f

create-volumes:
	for v in volm vol1 vol2 vol3; do docker volume create $$v; done

rm-volumes:
	for v in volm vol1 vol2 vol3; do docker volume rm $$v; done

upgrade-monitor: patch
	docker compose up -d --no-deps --build monitor

upgrade-nodes:
	docker compose up -d --no-deps --build node3 node2
	docker compose up -d --no-deps --build node1

state:
	docker compose exec monitor pg_autoctl show state

version:
	docker compose exec monitor pg_autoctl version
	docker compose exec monitor psql -d pg_auto_failover -c "$(Q_VERSION)"

failover:
	docker compose exec monitor pg_autoctl perform failover

watch:
	docker compose exec monitor watch -n 0.2 pg_autoctl show state

.PHONY: build patch clean up down upgrade-monitor state watch
.PHONY: compose-down compose-up create-volumes rm-volumes

=== src/bin/pg_autoctl/Makefile ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the PostgreSQL License.

PG_AUTOCTL = ./pg_autoctl

SRC_DIR := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))

DEPDIR = $(SRC_DIR)/.deps

INCLUDES  = $(patsubst ${SRC_DIR}%.h,%.h,$(wildcard ${SRC_DIR}*.h))

SRC   = $(patsubst ${SRC_DIR}%.c,%.c,$(wildcard ${SRC_DIR}*.c))
OBJS  = $(patsubst %.c,%.o,$(SRC))
OBJS += lib-log.o lib-commandline.o lib-parson.o lib-snprintf.o lib-strerror.o

PG_CONFIG ?= pg_config
BINDIR    ?= $(shell $(PG_CONFIG) --bindir)

PG_SNPRINTF     = $(wildcard ${SRC_DIR}../lib/pg/snprintf.*)
LOG_SRC         = $(wildcard ${SRC_DIR}../lib/log/src/log.*)
COMMANDLINE_SRC = $(wildcard ${SRC_DIR}../lib/subcommands.c/commandline.*)
PARSON_SRC      = $(wildcard ${SRC_DIR}../lib/parson/parson.*)

COMMON_LIBS  = -I${SRC_DIR}../lib/pg
COMMON_LIBS += -I${SRC_DIR}../lib/log/src/
COMMON_LIBS += -I${SRC_DIR}../lib/subcommands.c/
COMMON_LIBS += -I${SRC_DIR}../lib/libs/
COMMON_LIBS += -I${SRC_DIR}../lib/parson/

CC = $(shell $(PG_CONFIG) --cc)

DEFAULT_CFLAGS = -std=c99 -D_GNU_SOURCE -g
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --includedir)
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --includedir-server)
DEFAULT_CFLAGS += -I $(shell $(PG_CONFIG) --pkgincludedir)/internal
DEFAULT_CFLAGS += $(shell $(PG_CONFIG) --cflags)
DEFAULT_CFLAGS += -Wformat
DEFAULT_CFLAGS += -Wall
DEFAULT_CFLAGS += -Werror=implicit-int
DEFAULT_CFLAGS += -Werror=implicit-function-declaration
DEFAULT_CFLAGS += -Werror=return-type
DEFAULT_CFLAGS += -Wno-declaration-after-statement

# Needed for FreeBSD
DEFAULT_CFLAGS += -D_WANT_SEMUN

# Needed for OSX
DEFAULT_CFLAGS += -Wno-missing-braces
DEFAULT_CFLAGS += $(COMMON_LIBS)

ifdef USE_SECURITY_FLAGS
# Flags taken from: https://liquid.microsoft.com/Web/Object/Read/ms.security/Requirements/Microsoft.Security.SystemsADM.10203#guide
SECURITY_CFLAGS=-fstack-protector-strong -D_FORTIFY_SOURCE=2 -O2 -z noexecstack -fpie -Wl,-pie -Wl,-z,relro -Wl,-z,now -Wformat -Wformat-security -Werror=format-security
DEFAULT_CFLAGS += $(SECURITY_CFLAGS)
endif

override CFLAGS := $(DEFAULT_CFLAGS) $(CFLAGS)

LIBS  = -L $(shell $(PG_CONFIG) --pkglibdir)
LIBS += -L $(shell $(PG_CONFIG) --libdir)
LIBS += $(shell $(PG_CONFIG) --ldflags)
LIBS += $(shell $(PG_CONFIG) --libs)
LIBS += -lpq
LIBS += -lncurses

all: $(PG_AUTOCTL) ;

# Based on Postgres Makefile for automatic dependency generation
# https://github.com/postgres/postgres/blob/1933ae629e7b706c6c23673a381e778819db307d/src/Makefile.global.in#L890-L924
%.o : %.c
	@if test ! -d $(DEPDIR); then mkdir -p $(DEPDIR); fi
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -o $@ $<

Po_files := $(wildcard $(DEPDIR)/*.Po)
ifneq (,$(Po_files))
include $(Po_files)
endif


$(PG_AUTOCTL): $(OBJS) $(INCLUDES)
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(LIBS) -o $@

lib-snprintf.o: $(PG_SNPRINTF)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/snprintf.c

lib-strerror.o: $(PG_SNPRINTF)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/pg/strerror.c

lib-log.o: $(LOG_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/log/src/log.c

lib-commandline.o: $(COMMANDLINE_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/subcommands.c/commandline.c

lib-parson.o: $(PARSON_SRC)
	$(CC) $(CFLAGS) -c -MMD -MP -MF$(DEPDIR)/$(*F).Po -MT$@ -o $@ ${SRC_DIR}../lib/parson/parson.c

clean:
	rm -f $(OBJS) $(PG_AUTOCTL)
	rm -rf $(DEPDIR)

install: $(PG_AUTOCTL)
	install -d $(DESTDIR)$(BINDIR)
	install -m 0755 $(PG_AUTOCTL) $(DESTDIR)$(BINDIR)



.PHONY: all monitor clean

=== src/bin/lib/parson/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(parson C)

include (GNUInstallDirs)

set(PARSON_VERSION 1.5.3)
add_library(parson parson.c)
target_include_directories(parson PUBLIC $<INSTALL_INTERFACE:include>)

set_target_properties(parson PROPERTIES PUBLIC_HEADER "parson.h")
set_target_properties(parson PROPERTIES VERSION ${PARSON_VERSION})
set_target_properties(parson PROPERTIES SOVERSION ${PARSON_VERSION})

install(
    TARGETS parson
    EXPORT parsonTargets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT shlib
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(
    EXPORT parsonTargets
    FILE parsonConfig.cmake
    NAMESPACE parson::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

=== debian/changelog ===
pg-auto-failover (2.2-3) unstable; urgency=medium

  * Upload for PostgreSQL 18.
  * Build-Depends on libnuma-dev
  * Add patch to fix missing variable declarations error during build
  * Add patch to fix included copy of snprintf
  * Add patch to add variant comparison file for extension upgrade regress
    test
  * Add postgresql-common-dev to d/tests depends
  * Fix filenamemangle rule in d/watch

 -- Bradford D. Boyle <bradford.d.boyle@gmail.com>  Mon, 17 Nov 2025 12:24:16 +0100

pg-auto-failover (2.2-2) unstable; urgency=medium

  * Stop listing major versions explicitly in pg-auto-failover-cli's
    Recommends list. Use a generic postgresql-auto-failover virtual package
    instead. (Closes: #1095783)

 -- Christoph Berg <myon@debian.org>  Mon, 07 Apr 2025 12:33:40 +0200

pg-auto-failover (2.2-1) unstable; urgency=medium

  * New upstream version 2.2.
  * Packaging repository moved to salsa.

 -- Christoph Berg <myon@debian.org>  Thu, 03 Apr 2025 14:15:30 +0200

pg-auto-failover (2.1-3) unstable; urgency=medium

  * Upload for PostgreSQL 17.
  * Restrict to 64-bit architectures.
  * Use ${postgresql:Depends}.

 -- Christoph Berg <myon@debian.org>  Fri, 13 Sep 2024 14:31:10 +0200

=== debian/control ===
Source: pg-auto-failover
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Dimitri Fontaine <dim@tapoueh.org>,
 Christoph Berg <myon@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit <!pkg.postgresql.32-bit>,
 flex,
 libedit-dev,
 libkrb5-dev,
 liblz4-dev,
 libncurses-dev,
 libnuma-dev,
 libpam0g-dev,
 libreadline-dev,
 libselinux1-dev,
 libssl-dev,
 libxslt1-dev,
 libzstd-dev,
 postgresql-server-dev-all (>= 158~),
 python3-sphinx,
 zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/citusdata/pg_auto_failover
Vcs-Browser: https://salsa.debian.org/postgresql/pg-auto-failover
Vcs-Git: https://salsa.debian.org/postgresql/pg-auto-failover.git

Package: pg-auto-failover-cli
Architecture: any
Depends:
 openssl,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 postgresql-auto-failover,
Description: Command line interface and service to manage pg auto failover Clusters
 This CLI is used to manage pg_auto_failover installations to provide High
 Availability to Postgres.

Package: postgresql-18-auto-failover
Architecture: any
Depends:
 pg-auto-failover-cli (>= ${binary:Version}),
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
Breaks:
 ${postgresql:Breaks},
Provides:
 postgresql-auto-failover,
Description: Postgres high availability support
 This extension implements a set of functions to provide High Availability to
 Postgres.

=== debian/rules ===
#!/usr/bin/make -f

CLINAME := $(lastword $(shell grep "Package: pg-auto-failover-cli" debian/control))

include /usr/share/dpkg/pkg-info.mk
include /usr/share/postgresql-common/pgxs_debian_control.mk

export USE_SECURITY_FLAGS := 1

clean: debian/control

.PHONY: debian/control

override_dh_auto_build:
	echo "#define GIT_VERSION \"$(DEB_VERSION)\"" > src/bin/pg_autoctl/git-version.h
	+make -C $(shell pwd)/src/bin/pg_autoctl
	+pg_buildext build $(shell pwd)/src/monitor build-%v
	+make man

override_dh_auto_clean:
	+make -C $(shell pwd)/src/bin/pg_autoctl clean
	+pg_buildext clean $(shell pwd)/src/monitor build-%v

override_dh_auto_test:
	# nothing to do here, see debian/tests/* instead

override_dh_auto_install:
	+make -C $(shell pwd)/src/bin/pg_autoctl install \
		DESTDIR=$(CURDIR)/debian/${CLINAME} \
		BINDIR=/usr/bin
	+pg_buildext install $(shell pwd)/src/monitor build-%v postgresql-%v-auto-failover
	dh_installman docs/_build/man/*

%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://github.com/citusdata/pg_auto_failover/tags .*/v?(\d\S*)\.tar\.gz
